<?php 

require '../../../wp-load.php';

function slt_url_to_postid( $url ) {
	// Try the core function
	$post_id = url_to_postid( $url );
	if ( $post_id == 0 ) {
		// Try custom post types
		$cpts = get_post_types( array(
			'public'   => true,
			'_builtin' => false
		), 'objects', 'and' );
		// Get path from URL
		$url_parts = explode( '/', trim( $url, '/' ) );
		$url_parts = array_splice( $url_parts, 3 );
		$path = implode( '/', $url_parts );
		// Test against each CPT's rewrite slug
		foreach ( $cpts as $cpt_name => $cpt ) {
			$cpt_slug = $cpt->rewrite['slug'];
			if ( strlen( $path ) > strlen( $cpt_slug ) && substr( $path, 0, strlen( $cpt_slug ) ) == $cpt_slug ) {
				$slug = substr( $path, strlen( $cpt_slug ) );
				$query = new WP_Query( array(
					'post_type'			=> $cpt_name,
					'name'				=> $slug,
					'posts_per_page'	=> 1
				));
				if ( is_object( $query->post ) )
					$post_id = $query->post->ID;
			}
		}
	}
	return $post_id;
}

if ($_GET[method] && $_GET['act'] != 'del') {

		if (! function_exists('curl_init')) { echo 'ALERT!'; }

		// основные переменные
		$params = maybe_unserialize(get_option('smli_params'));
		$links = $_GET[reindex] || $_GET[reindex_st2] ? array() : maybe_unserialize(get_option('smli'));
		$relinks = $_GET[reindex] ? get_refined_links_wstamp() : false ;
		$links_upd = $_GET[reindex] ? $relinks[1] : $_POST[smli] ;
		$method = $_GET['method'];

		if ($_GET[reindex] || $_GET[reindex_st2]) {
			delete_post_meta_by_key( '_smli' );
			delete_post_meta_by_key( '_smli_count' );
			$smli = get_posts (array(
				'meta_key' => '_smli',
				'numberposts'	=> -1
			));

			foreach ($smli as $post) {
				delete_post_meta($post->ID, '_smli');
				delete_post_meta($post->ID, '_smli_count');
			}			
			foreach ($smli as $post) {
				$smli_cnt = 'hello';
				$smli_cnt = get_post_meta($post->ID, '_smli');
			}			
			$smli_2 = get_posts (array(
				'meta_key' => '_smli',
				'numberposts'	=> -1
			));
			$smli_2b = get_posts (array(
				'meta_key' => '_smli_count',
				'numberposts'	=> -1
			));
			foreach ($smli_2b as $post) {
				delete_post_meta($post->ID, '_smli');
				delete_post_meta($post->ID, '_smli_count');
			}			
		}

		// обновление массива ссылок и сборка/фильтрация id релевантных страниц
		ksort($links_upd, SORT_NUMERIC);
		$keys_alpha = array_keys($links_upd);

		foreach ($links_upd as $k => $link) {
			if ($k > 1000000) {
				# даем новой ссылке идентификатор и помещаем в обновленных массив ссылок
				$link_id = array_pop(array_keys($links)) ? array_pop(array_keys($links))+1 : 1 ;
				$links[$link_id] = $link;

				switch ($method) {
				# подбор релевантных записей по категориям/тегам
					case 'w':
					case 'tags':
					case 'cats':
						$id = url_to_postid($link[href]);
						$args = array(
							'showposts' => -1,
							'orderby' => 'rand',
							'exclude' => $id
						);
						// используем категории как критерий подбора, если необходимо
						if (in_array($method, array('w','cats'))) {
							unset($cats_id);
							$cats = get_the_category($id);
							foreach ($cats as $cat) {
								$cats_id[] = $cat->cat_ID;
							}
							$args['category__in'] = $cats_id;
						}
						// используем теги как критерий подбора, если необходимо
						if (in_array($method, array('w','tags'))) {
							unset($tags_id);
							$tags = get_the_tags($id);
							foreach ($tags as $tag) {
								$tags_id[] = $tag->term_id;
							}
							$args['tag__in'] = $tags_id;
						}	
						// строим массив с id релевантных записей
						$posts = get_posts($args);
						foreach ($posts as $post) {
							$ids[$link_id][] = $post->ID;
						}
						break;

				# отсеиваем записи
					case 'y':

						if ($method == 'y') {


							$user = $params['user']; 
							$key = $params['ykey']; 
							$home = get_option('home');
							$home = str_replace('http://', '', $home);
							$query = urlencode("$link[anchor] host:$home");
							$get_url = "http://xmlsearch.yandex.ru/xmlsearch?user={$user}&key={$key}&query={$query}&groupby=mode%3Dflat.groups-on-page%3D50.docs-in-group%3D1";
							$xml = file_get_contents($get_url);
							$xml = simplexml_load_string($xml);
							$xml = simplexml_clean_object($xml);


							$link[urls] = get_the_cake($xml, 2);	
				
						} 
						// строим массив с id релевантных записей
						foreach ($link[urls] as $key => $url) {
						  $curr_id = url_to_postid($link[href]);
						  $id = url_to_postid($url);
						  if (get_post_type($id) == 'post' && $curr_id != $id && $id) {
						    $ids[$link_id][] = $id;
						  }
						}			
						break;
				}			

			} else {
				# замена информации по старой ссылке
				$links[$k] = $link;
			}
		}

		// сохранение изменений по ссылкам
		update_option('smli',$links);

		$keys_beta = array_keys($links);


		if ($_POST['smli_pr'] ) {
			$_POST['smli_pr'] = explode(',', $_POST['smli_pr']);
		} else {
			$_POST['smli_pr'] = get_option('smli_pr') ? explode(',', get_option('smli_pr') ) : $keys_beta ;
		}

		foreach ($keys_alpha as $k => $val) {
			$old_lid = $relinks ? $val-$relinks[0] : $val ;
			$new_lid = $keys_beta[$k];
			$pr_k = array_search($old_lid, $_POST['smli_pr']);
			$_POST['smli_pr'][$pr_k] = $new_lid;
		}

		update_option('smli_pr',implode(',', $_POST['smli_pr']));
		
		// прикрепление ссылок к записям
		if ($ids) {
			foreach ($ids as $link_id => $post_ids) {
				foreach ($post_ids as $post_id) {
					// >>
					$curr_links_count = get_post_meta($post_id, '_smli_count', 1);
					if ($curr_links_count < $params['count']) {
					// >>
							$curr_links = get_post_meta($post_id, '_smli', 1);
							if (is_array($curr_links)) { $curr_links[] = $link_id; }
							else { $curr_links = array($link_id); }
							update_post_meta($post_id, '_smli', $curr_links);
					// >>
						update_post_meta($post_id, '_smli_count', count($curr_links));
					}	
					// >>
				}
			}			
		}



} elseif ($_GET['act'] == 'del') { 
	// получаем в переменные ключи ссылок и ссылки 
	print_r($_REQUEST);
	$keys = explode(',',$_POST['keys']);
	$links = maybe_unserialize(get_option('smli'));
	$pkeys = $_POST['pkeys'] ? explode(',', $_POST['pkeys'])  : '' ;
	foreach ($keys as $key) {
		// по ключу удаляем ссылку из массива
		unset($links[$key]);
		$posts = get_posts( array(
			'showposts'		=> -1,
			'meta_key'		=> '_smli',
			'meta_value'	=> "\"$key\"",
			'meta_compare' 	=> 'LIKE'
		));
		foreach ($posts as $p) {
			// получаем ссылки записи
			$curr_links = maybe_unserialize(get_post_meta($p->ID, '_smli', 1));
			// проверяем действительное наличие ссылки
			if (in_array($key, $curr_links)) {
				// получаем кол-во ссылок в блоке записи, удаляем ссылку из массива
				unset($curr_links[array_search($key, $curr_links)]);
				$curr_count = get_post_meta($p->ID, '_smli_count', 1);
				// уменьшаем значение кол-ва, обновляем значения
				update_post_meta($p->ID,'_smli',$curr_links);
				update_post_meta($p->ID,'_smli_count',$curr_count-1);
			}
		}
	}
	$pkeys = implode(',', $pkeys);
	// обновляем массив ссылок
	update_option('smli', $links);
	update_option('smli_pr', $pkeys);
}