<?php
/*
Plugin Name: Smart Linker Pro
Plugin URI: http://smart-linker.ru/
Description: <strong><a href="http://smart-linker.ru/">Smart Linker Pro</a></strong> - скрипт внутренней перелинковки сайта с целью продвижения страниц по необходимым ключевым запросам с использованием поисковой системы Яндекс. <strong>Полезные ссылки:</strong> <a href="http://shop.pervushin.com/wp-smart-linker-pro.html">Купить Pro версию</a> | <a href="http://smart-linker.ru/forum/">Форум</a> | <a href="http://smart-linker.ru/forum/viewforum.php?f=5">FAQ</a>
Version: 0.9.1
Author: Сергей Первушин и Dmitry NoNueve
Author URI: http://pervushin.com/
Author Email: sergey@pervushin.com
*/

define('SMLI_HANDLER', plugins_url('handler.php', __FILE__));
define('SMLI_EXPORT', plugins_url('export.php', __FILE__));

add_action( 'reindex_daily', 'start_reindex' );


add_action( 'reindex_daily', 'start_reindex' );
function start_reindex ()
{
	$params = maybe_unserialize(get_option('smli_params'));
	$method = $params['method'];
	$handler = SMLI_HANDLER . "?method={$method}&reindex=true";

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $handler);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	$response = curl_exec($ch);
	curl_close($ch);
}

function smli_install () {
	$params = maybe_unserialize(get_option('smli_params'));
	if (!$params) {
		$params_default = array(
			'method' => 'tags',
			'count' => 5,
			'autoreindex' => 1
		);
		update_option('smli_params', $params_default);
		$params = $params_default;
	}
	if( !wp_next_scheduled( 'reindex_daily' ) ) {  
	   wp_schedule_event( time(), 'daily', 'reindex_daily' );  
	} 
}
register_activation_hook( __FILE__, 'smli_install');

function smli_deactivation ()
{
	wp_clear_scheduled_hook( 'reindex_daily' ); 
}
register_deactivation_hook( __FILE__, 'smli_deactivation');

function smli_uninstall () {
	$options = array('smli_last_ver_check', 'smli_new_ver', 'smli', 'smli_params');
	foreach ($options as $options => $option) {
		delete_option($option);
	}
}
register_uninstall_hook( __FILE__, 'smli_uninstall');

### output ###

function the_smli($post_id = 0) {
	if (!$post_id) { global $post; $post_id = $post->ID; }
	$params = maybe_unserialize(get_option('smli_params'));
	$links = maybe_unserialize(get_option('smli'));
	$curr_links = get_post_meta($post_id, '_smli', 1);
	$smli_pr = get_option('smli_pr') ? explode(',', get_option('smli_pr')) : false ;
	if (is_array($smli_pr) && is_array($curr_links)) {
		foreach ($smli_pr as $l)
		{
			if (in_array($l, $curr_links)) { $sorted_curr_links[] = $l; }
		}
	}
	$curr_links = $sorted_curr_links;

	if ($curr_links) {
?>

	<div class="<?=stripslashes($params['class']) ? stripslashes($params['class']): 'smli_default'?>">
		<h4><?=stripslashes($params['title'])?></h4>
		<ul>
<?php
	$history = array();
	foreach ($curr_links as $link_id) {
			$link = $links[$link_id];
			if (is_array($link)) {
				extract($link); 
				if (!in_array($href, $history)) {
					$history[] = $href;
?>
			<li>
				<?=stripslashes($before)?><a href="<?=$href?>" title="<?=stripslashes($anchor)?>"><?=stripslashes($anchor)?></a><?=stripslashes($after)?>
			</li>
			<?php } } ?>	
<?php } ?>	
		</ul>
	</div>	

<?php

	}
}

### manage page ###

function smli_page () {

	$links = maybe_unserialize(get_option('smli'));
	$params = maybe_unserialize(get_option('smli_params'));
	$home = get_option('home');
	// [x1-0207] 
	wp_enqueue_style('smli-style', plugins_url('css/style.css', __FILE__)); 
?>

<script>
	var smliParams = {
		method: '<?=stripslashes($params[method])?>',
		gkey: '<?=stripslashes($params[gkey])?>', 
		cx:  '<?=stripslashes($params[cx])?>',
		site:  '<?=$home?>'
	};	
</script>

<div class="wrap">
<div id="icon-options-general" class="icon32"><br></div> <h2>Управление перелинковкой</h2>	
<br>

<?php

$rt_import = $_POST['import'];
if ($rt_import) {

	$rt_txt = iconv('windows-1251', 'UTF-8', file_get_contents($_FILES['csv']['tmp_name']));
	$rt_pairs = array();
	$lines = explode("\n", $rt_txt);
	foreach ($lines as $line) {
		if ( mb_strpos($line, ';') ) 
		{
			$rt_pairs[] = explode(';', $line);
		}
	}

	$links = get_option('smli') ? maybe_unserialize(get_option('smli')) : array();
	$smli_pr = get_option('smli_pr') ? explode(',', get_option('smli_pr')) : array() ;

		foreach ($rt_pairs as $k => $pair) {
			if (!$pair[0] || !$pair[1]) { unset($rt_pairs[$k]); }
			else {
				$links["999999{$k}"]['before'] = '';
				$links["999999{$k}"]['after'] = '';
				$links["999999{$k}"]['anchor'] = $pair[0];
				$links["999999{$k}"]['href'] = $pair[1];
				$smli_pr[] = "999999{$k}";
			}
		}

	    foreach ($links as $k => $link) {
	    	foreach ($link as $link_field_name => $link_field_val) {
	    		$links[$k][$link_field_name] = @stripcslashes($link_field_val);
	    	}
	    }

	    $links = http_build_query(array('smli' => $links, 'smli_pr' => implode(',', $smli_pr)));

	    $params = maybe_unserialize(get_option('smli_params'));
	    $method = $params['method'];
		$handler = SMLI_HANDLER . "?method={$method}&";
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL, $handler);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $links);

	    $response = curl_exec($ch);
	    curl_close($ch);

	    global $wpdb;
	    $links_opt = $wpdb->get_row( $wpdb->prepare( "SELECT option_value FROM $wpdb->options WHERE option_name = %s LIMIT 1", 'smli' ) );
		$links = is_object( $links_opt ) ? maybe_unserialize($links_opt->option_value) : array() ;

?>
	<script type="text/javascript">
		location.reload();
	</script>
<?php

}
?>

<style>
	body
  	{
  		counter-reset:smlink;
  	}
  	
  	#smli-links  .smli-cb:after
  	{
  		content: counter(smlink) " ";
 		counter-increment:smlink;
  	}

	.smli-cb {
		width: 65px !important;
	}
	.smli-cb input { margin-right: 10px !important; }
</style>

<form action="<?=plugins_url('handler.php', __FILE__)?>" id="smliform" method="post" accept-charset="utf-8">
<input type="hidden" name="smli_pr" value="<?=get_option('smli_pr')?>">
<br>
<a href="#" class="button smli-add">Добавить еще</a>
<a href="#" class="button-primary smli-del">Удалить</a>
<a href="#" class="button-primary smli-save">Сохранить</a>
<br><br>
<table class="wp-list-table widefat fixed posts" cellspacing="0">
    <thead>
        <tr>
            <th scope="col" class="smli-cb">
            	<input type="checkbox">
            </th>
            <th scope="col" id="title" class="manage-column column-title  desc">
            	Текст до
            </th>
            <th scope="col" id="title" class="manage-column column-title  desc">
            	Анкор
            </th>
            <th scope="col" id="title" class="manage-column column-title  desc">
            	Текст после
            </th>
            <th scope="col" id="title" class="manage-column column-title  desc">
            	URL
            </th>
        </tr>
    </thead>
    <tfoot>
        <tr>
        </tr>
    </tfoot>
    <tbody id="smli-links">

<?php 
	if ($links) { 
		$pr = get_option('smli_pr') ? explode(',', get_option('smli_pr')) : false ;

		if ($pr && is_array($links) && !empty($links)) {
			foreach ($pr as $k => $val) {
				$links_sorted[$val] = $links[$val];
			}
		} else {
			$links_sorted = $links;
		}

		foreach ($links_sorted as $k => $link) {
			extract($link);
?>
        <tr class="post" valign="top" data-k="<?=$k?>">
				<th scope="col" class="smli-cb">
            	<input type="checkbox" data-k="<?=$k?>">
				</th>
            <td>
                <input type="text" name="smli[<?=$k?>][before]" data-k="<?=$k?>" class="smli-before large-text" placeholder="Текст до"  value="<?=esc_attr(stripslashes(
$before))?>">
            </td>
            <td>
                <input type="text" name="smli[<?=$k?>][anchor]" data-k="<?=$k?>" class="smli-anchor large-text" placeholder="Анкор" value="<?=esc_attr(stripslashes(
$anchor))?>">
            </td>
            <td>
                <input type="text" name="smli[<?=$k?>][after]" data-k="<?=$k?>" class="smli-after large-text" placeholder="Текст после" value="<?=esc_attr(stripslashes(
$after))?>">
            </td>
            <td> 
                <input type="text" name="smli[<?=$k?>][href]" data-k="<?=$k?>" class="smli-href large-text" placeholder="URL" value="<?=esc_attr(stripslashes(
$href))?>">
            </td>
        </tr>
<?php
		}
	} else {
?>
        <tr class="post" valign="top" data-k="9999999">
				<th scope="col" class="smli-cb">
            	<input type="checkbox" data-k="9999999">
				</th>
            <td> 
                <input type="text" name="smli[9999999][before]" data-k="9999999" class="smli-before large-text" placeholder="Текст до" value="">
            </td>
            <td>
                <input type="text" name="smli[9999999][anchor]" data-k="9999999" class="smli-anchor large-text" placeholder="Анкор">
            </td>
            <td>
                <input type="text" name="smli[9999999][after]" data-k="9999999" class="smli-after large-text" placeholder="Текст после">
            </td>
            <td>
                <input type="text" name="smli[9999999][href]" data-k="9999999" class="smli-href large-text" placeholder="URL">
            </td>
        </tr>
<?php		
	}
?>

    </tbody>
</table>
<br>
	<p class="search-box">
		<a href="#" class="button smli-add">Добавить еще</a>
		<a href="#" class="button-primary smli-del">Удалить</a>
		<a href="#" class="button-primary smli-save">Сохранить</a>
	</p>
</form>
</div>

<div style="display:none;">
	<?
		$dino = get_posts(array(
				'meta_key' => '_smli',
				'numberposts'	=> -1
			));
		foreach ($dino as $dp) {
			$dpid = $dp->ID;
			echo "<p><a href='".get_permalink( $dpid )."'>".get_the_title($dpid)."</a> (".count(get_post_meta( $dpid, '_smli', 1 )).")</p>";
		}
	?>
</div>

<?php
}

### options page ###

function smli_options_page () {
	$home = get_option('home'); 
	$ip = $_SERVER["SERVER_ADDR"];   
	$smli_key = get_option('smli_key');
	if ($_POST['yep']) {
		update_option('smli_params',$_POST['smli']);
		update_option('smli_key',$_POST['smli_key']);
		update_option('smli_email',$_POST['smli_email']);
		$smli_key = $_POST['smli_key'];
		$smli_email = $_POST['smli_email'];
		if (!is_smli_activated() && $smli_email) { send_smli_activation_req($smli_key, $smli_email); }
		if( !wp_next_scheduled( 'reindex_daily' ) && $_POST['smli']['autoreindex'] ) {  
			wp_schedule_event( time(), 'daily', 'reindex_daily' );  
		} elseif ( !$_POST['smli']['autoreindex'] ) {
			wp_clear_scheduled_hook( 'reindex_daily' ); 
		}
		extract($_POST['smli']);
	} else {
		extract(get_option('smli_params') ? maybe_unserialize(get_option('smli_params')) : array());
	}
	// [x1-0207]
?>


<script>
	var smliParams = {
		method: '<?=stripslashes($method)?>',
		gkey: '<?=stripslashes($gkey)?>', 
		cx:  '<?=stripslashes($cx)?>',
		site:  '<?=$home?>',
		handler: '<?=plugins_url('handler.php', __FILE__)?>'

	};	
</script>

<div class="wrap">
<div id="icon-ms-admin" class="icon32"><br></div> <h2>Настройки и доступы</h2>	
<br>
<form id="smliform" method="post">
	<table class="form-table">
		<tbody>
		<tr valign="top">
				<th scope="row" style="width: 300px;">
					<h3 style="color:red;">Доступ к премиум-возможностям <?php if (!is_smli_activated()) { ?>(<a href="http://shop.pervushin.com/wp-smart-linker-pro.html" target="blank">купить</a>)<?php } ?></h3>
				</th>
				<td></td>
			</tr>
			<?php if (!is_smli_activated()) { ?>
			<th scope="row"><label for="smliemail">E-mail</label></th>
				<td>
					<input name="smli_email" type="text" id="smliemail" value="<?=stripslashes($smli_email)?>" class="regular-text">
				</td>
			</tr>
			<?php } ?>
			<th scope="row"><label for="smlikey">PIN-код</label></th>
				<td>
				<?php if (!is_smli_activated()) { 
					?>
					<input name="smli_key" type="text" id="smlikey" value="<?=stripslashes($smli_key)?>" class="regular-text">
					<p class="submit">
		<input type="submit" name="submit" id="submit" class="button-primary" value="Активировать">
	</p>
				<?php }  else { ?>
					<p class="description">Лицензия активирована</p>
					<input name="smli_key" type="hidden" id="smlikey" value="<?=stripslashes($smli_key)?>" class="regular-text">
				<?php } ?>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="width: 300px;">
					<h3>Основные настройки</h3>
				</th>
				<td></td>
			</tr>
			<th scope="row"><label for="method">Способ подбора</label></th>
				<td>
					<select name="smli[method]" id="method">
						<option <?=selected($method,'tags')?> value="tags">Теги</option>
						<option <?=selected($method,'cats')?> value="cats">Категории</option>
						<option <?=selected($method,'w')?> value="w">Теги и категории</option>
						<? if(is_smli_activated()) { ?>
						<option <?=selected($method,'y')?> value="y">Яндекс</option>
						<? } ?>
					</select>
				</td>
			</tr>
			<th scope="row"><label>Реиндексация</label></th>
				<td>
					<input type="button" id="reindex" class="button-primary" value="Произвести">	
				</td>
			</tr>	
<th scope="row"><label for="reday">Проводить реиндекс ежедневно</label></th>
				<td>
					<input type="checkbox" id="reday" <?=checked($autoreindex, 1)?> name="smli[autoreindex]" value="1">	
				</td>
			</tr>			
			<? if(is_smli_activated()) { ?>
			<tr valign="top">
				<th scope="row">
					<h3>Доступ к API Яндекс</h3>
				</th>
				<td></td>
			</tr>
			<th scope="row"><label for="user">Пользователь</label></th>
				<td>
					<input name="smli[user]" type="text" id="user" value="<?=stripslashes($user)?>" class="regular-text">
				</td>
			</tr>
			<th scope="row"><label for="ip">IP</label></th>
				<td>
					<input name="" disabled="disabled" type="text" id="ip" value="<?=$ip?>" class="regular-text">
				</td>
			</tr>
			<th scope="row"><label for="ykey">Ключ</label></th>
				<td>
					<input name="smli[ykey]" type="text" id="ykey" value="<?=stripslashes($ykey)?>" class="regular-text">
				</td>
			</tr>
		  <? /* <tr valign="top"> 
				<th scope="row">
					<h3>Доступ к API Google</h3>
				</th>
				<td></td>
			</tr>
			<th scope="row"><label for="gkey">Ключ</label></th>
				<td>
					<input name="smli[gkey]" type="text" id="gkey" value="<?=stripslashes($gkey)?>" class="regular-text">
				</td>
			</tr>
			<th scope="row"><label for="cx">CSE id</label></th>
				<td>
					<input name="smli[cx]" type="text" id="cx" value="<?=stripslashes($cx)?>" class="regular-text">
				</td>
			</tr>  */ ?>
			<? } ?>
			<tr valign="top">
				<th scope="row">
					<h3>Блок ссылок</h3>
				</th>
				<td></td>
			</tr>
			<th scope="row"><label for="class">Класс контейнера</label></th>
				<td>
					<input name="smli[class]" type="text" id="class" value="<?=stripslashes($class)?>" class="regular-text">
				</td>
			</tr>
			<th scope="row"><label for="title">Заголовок</label></th>
				<td>
					<input name="smli[title]" type="text" id="title" value="<?=stripslashes($title)?>" class="regular-text">
				</td>
			</tr>
			<th scope="row"><label for="count">Количество ссылок</label></th>
				<td>
					<input name="smli[count]" type="text" id="count" value="<?=stripslashes($count)?>" class="regular-text">
				</td>
			</tr>
		</tbody>
	</table>
	<br>
	<input type="hidden" name="yep" value="1">
	<p class="submit">
		<input type="submit" name="submit" id="submit" class="button-primary" value="Сохранить изменения">
	</p>
</form>
</div>
<?php
}

function smli_import_page () {
?>

	<div class="wrap">
	<div id="icon-edit-pages" class="icon32 icon32-posts-page"><br></div>
	<h2>Импорт</h2>	
	<form id="smliform" method="post" enctype="multipart/form-data" action="<?=get_admin_url('', 'admin.php?page=smli')?>">
		<p>Загружаемый файл должен быть строго в формате txt. В каждой строке должен быть указан анкор и URL. Эти значения разделяются точкой с запятой (;). <a href="http://smart-linker.ru/example/txt_file_example.txt" target="_blank">Скачайте пример файла</a>.</p>
		<strong>Загрузить файл</strong> <input type="file" name="csv">
		<input type="hidden" name="import" value="yup">
		<span class="submit">
			<input type="submit" name="submit" id="submit" class="button-primary" value="Запустить импорт">
		</span>
	</form>
	</div>
<?php
}


function smli_export_page () {
?>

	<div class="wrap">
	<div id="icon-edit-pages" class="icon32 icon32-posts-page"><br></div>
	<h2>Экспорт</h2>	
	<form id="smliform" method="post" action="<?=SMLI_EXPORT?>">
		<p><strong>Что будем экспортировать</strong></p>
		<label>
			<input type="checkbox" checked="checked" name="before"> Текст до
		</label>  <strong>|</strong>  
		<label>
			<input type="checkbox" checked="checked" name="anchor"> Анкор
		</label>  <strong>|</strong>  
		<label>
			<input type="checkbox" checked="checked" name="after"> Текст после
		</label>  <strong>|</strong>  
		<label>
			<input type="checkbox" checked="checked" name="href"> URL
		</label>
		<input type="hidden" name="export" value="yup"><br>
		<p class="submit">
			<input type="submit" name="submit" id="submit" class="button-primary" value="Получить файл">
		</p>
	</form>
	</div>
<?php
}


### actions ###

function create_smli_pages () {
	add_menu_page('Управление перелинковкой','WP SL Pro','manage_options','smli', 'smli_page');
	add_submenu_page('smli','Настройки и доступы', 'Настройки', 'manage_options','smli_options', 'smli_options_page');
	add_submenu_page('smli','Импорт', 'Импорт', 'manage_options','smli_import', 'smli_import_page');
	add_submenu_page('smli','Экспорт', 'Экспорт', 'manage_options','smli_export', 'smli_export_page');
}
add_action('admin_menu','create_smli_pages');

### functions ###

	function get_the_cake ($stuff, $cake_code = 0) {
		$domain = get_option( 'home' );
		$license_key = get_option( 'smli_key' );
		$ch = curl_init();

	    curl_setopt($ch, CURLOPT_URL, "http://smart-linker.ru/supermind/?" . http_build_query(array(
			 'cc' => $cake_code
			,'s' => $stuff
			,'k' => $license_key
			,'d' => $domain
		)));
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-type: multipart/form-data"));
		$cake = curl_exec($ch);
		curl_close($ch);
		return unserialize($cake);
	}
	
	function send_smli_activation_req ($license_key, $email = '') {
		$domain = get_option( 'home' );
		$domain = urlencode($domain);
		$license_key = urlencode($license_key);
		$email = urlencode($email);
		$result = unserialize(@file_get_contents("http://smart-linker.ru/supermind/?cc=420&k={$license_key}&d={$domain}&m={$email}"));
		if ('itsokay' == $result['youknow']) { update_option( 'smli_activated', 1 ); }
	}

	function is_smli_activated () {
		return ( get_option( 'smli_activated' ) ? true : false );
	}

###

function smli_check_reqrd () {

	if  (in_array  ('curl', get_loaded_extensions())) {
		add_action( 'admin_notices', 'smli_check_reqrd_yep' );
	}
	else{
		add_action( 'admin_notices', 'smli_check_reqrd_nope' );
	}

}
add_action( 'init', 'smli_check_reqrd' );

function smli_check_reqrd_yep () {
?>
<?php
}

function smli_check_reqrd_nope () {
?>
	<style>
	.update-nag-error {
			background-color: #FFEBE8 !important;
			border-color: #C00 !important;		
	}
	</style>
	<div class="update-nag update-nag-error">
		Нет доступа к расширению PHP cURL. Пожалуйста, обратитесь в тех. поддержку хостинга для его активации.
	</div>
<?php
}

###

function get_refined_links () {
	$links = get_option('smli') ? maybe_unserialize(get_option('smli')) : array();
	$links_upd = array();
	$timestamp = time();
	foreach ($links as $k => $link) {
		$link['urls'] = array();
		$links_upd[$timestamp+$k] = $link;
	}
	return $links_upd;
}

function simplexml_clean_object ($xml = '') {
	$ems = array();
	if (is_object($xml)) {
		$results = $xml->response->results->grouping;
		foreach ($results->group as $em) {
		  $ems[] = strtolower((string)$em->doc->url);
		}	
	}
	return $ems;
}

function get_refined_links_wstamp () {
	$links = get_option('smli') ? maybe_unserialize(get_option('smli')) : array();
	$links_upd = array();
	$timestamp = time();
	foreach ($links as $k => $link) {
		$link['urls'] = array();
		$links_upd[$timestamp+$k] = $link;
	}
	return array($timestamp, $links_upd);
}

### update notification ###

require_once(ABSPATH.'/wp-admin/includes/plugin.php');
add_action('admin_head','smli_plugin_check_ver');

$plugin_sn= "smli";
$remote_file = "http://smart-linker.ru/version/smli_pro.txt";
$update_check_int = 48; 


$plugin_data = get_plugin_data(__FILE__);
$local_version = $plugin_data['Version'];
$update_last_check = get_option($plugin_sn.'_last_ver_check');
$new_ver_notice = get_option($plugin_sn.'_new_ver');
$saved_version = get_option($plugin_sn.'_saved_ver');

$plugin_update_notice = file_get_contents( "http://smart-linker.ru/version/new_version_contents.txt" );

function smli_plugin_check_ver() {
	global $update_check_int, $update_last_check,$new_ver_notice,$plugin_sn;
		if ($new_ver_notice == true) {
			add_action('admin_notices','smli_plugin_new_ver');
		}
		$update_check_int_seconds = $update_check_int * 3600;
		$now = time();
		if ( empty( $update_last_check ) || $saved_version == $local_version ) {
				smli_plugin_compare_ver();
				add_option($plugin_sn.'_last_ver_check', $now);
			} else {
				$time_ago = $now - $update_last_check;
				if ( $time_ago > $update_check_int_seconds ) {
					smli_plugin_compare_ver();
					update_option($plugin_sn.'_last_ver_check', $now);
				}
			}
}
function smli_plugin_compare_ver() {
	global $remote_file, $local_version,$plugin_sn;
		$remote_text = @file_get_contents($remote_file);
		if ($remote_text !== false) {
			$saved_version = $remote_text;
			update_option($plugin_sn.'_saved_ver', $saved_version);
			$remote_version = $remote_text;
		if ($local_version == $remote_version) {
				delete_option($plugin_sn.'_new_ver');
			} else {
				if ( is_numeric(str_replace(".", "", $local_version)) && is_numeric(str_replace(".", "", $remote_version)) ) {
					if ( substr_count($local_version, '.') == 0 ) {
						// x -> x.x.x.x
						$local_version = $local_version . '.0.0.0';
					} else if ( substr_count($local_version, '.') == 1 ) {
						// x.x -> x.x.x.x
						$local_version = $local_version . '.0.0';
					} else if ( substr_count($local_version, '.') == 2 ) {
						// x.x.x -> x.x.x.x
						$local_version = $local_version . '.0';
					}
					$local_version = str_replace(".", "", $local_version);
					$local_version = '0.' . $local_version;
					if ( substr_count($remote_version, '.') == 0 ) {
						// x -> x.x.x.x
						$remote_version = $remote_version . '.0.0.0';
					} else if ( substr_count($remote_version, '.') == 1 ) {
						// x.x -> x.x.x.x
						$remote_version = $remote_version . '.0.0';
					} else if ( substr_count($remote_version, '.') == 2 ) {
						// x.x.x -> x.x.x.x
						$remote_version = $remote_version . '.0';
					}
					$remote_version = str_replace(".", "", $remote_version);
					$remote_version = '0.' . $remote_version;
					if ( $remote_version > $local_version ) {
						add_action('admin_notices','smli_plugin_new_ver');
						add_option($plugin_sn.'_new_ver',true);
					} else {
						delete_option($plugin_sn.'_new_ver');
					}
				} else {
					add_action('admin_notices','smli_plugin_new_ver');
					add_option($plugin_sn.'_new_ver',true);
				}
			}
		} else {
			// проблема подключения к серверу обновлений
		}
}	
function smli_plugin_new_ver() { 
	global $plugin_update_notice, $pagenow;
?>
		<div class="update-nag">
		<?php echo $plugin_update_notice; ?>
		</div>
<?php
}

##
## [x1-0207]

function smli_enq_scripts($hook) {
	if ('smli' == $_GET['page']) {
		wp_enqueue_script('jquery-form', 'http://yandex.st/jquery/form/3.09/jquery.form.min.js', array('jquery')); 
		wp_enqueue_script('jquery-ui-core'); 
		wp_enqueue_script('jquery-ui-sortable'); 
		wp_enqueue_script('smli-manage', plugins_url('js/manage.js', __FILE__), array('jquery', 'jquery-ui-core', 'jquery-ui-sortable')); 
	} elseif ('smli_options' == $_GET['page']) {
		wp_enqueue_script('jquery-form', 'http://yandex.st/jquery/form/3.09/jquery.form.min.js', array('jquery')); 
		wp_enqueue_script('smli-options', plugins_url('js/options.js', __FILE__), array('jquery')); 		
	}
}
add_action( 'admin_enqueue_scripts', 'smli_enq_scripts' );

## [x1-0207]
##

?>